#include <fpp.h>
#include <hash.h>

#if STDC
void
doundef(const char *s)
#else /* NOT STDC */
void
doundef(s)				/* expect name */
const char *s;
#endif /* STDC */
{
    int n;

    if (PERMANENT(s))
    {
	error("Permanent symbol [", s, "] cannot be undefined", 0);
	return;
    }

    if (fpp_debug)
    {
	FPRINTF(stddbg,"%s:DEBUG: Macro: %s=--UNDEFINED--\n",
		fpp_dbgprefix(), s);
	FFLUSH(stddbg);
    }

    PRINTF("%s Macro: %s=--UNDEFINED--\n",out_prefix,s);

    n = lookup(s);
    if (n >= 0)
    {
	if (hash_value[n] != (char*)NULL)
	    free((void*)hash_value[n]);
	hash_value[n] = (char*)NULL;
	if (hash_name[n] != (char*)NULL)/* preserve entry so hash lookup */
	    hash_name[n][0] = '\0';	/* does not break */
    }
}
