/***********************************************************************
C implementation of a reversible Fortran preprocessor, modelled on a
prototype written in new awk().
[23-Dec-1990]
***********************************************************************/

#define EXTERN

#include <fpp.h>

#if defined(__TURBOC__)
unsigned _stklen = 0xF000;	/* Seems to be big enough.  Turbo C 2.0
				ignores any size set in the .exe file by
				LINK or EXEMOD, sigh... */
#endif /* defined(__TURBOC__) */

extern const char *fpp_cwd;
extern const char *fpp_personal_name;
extern const char *fpp_user_name;
extern char fpp_hostname[];
extern char fpp_timestamp[];

const char *
fpp_dbgprefix(VOID_ARG)
{
    static char buffer[MAXLINE+1+sizeof("18446744073709551615")+1]; /* 2^64 - 1 */
    size_t n;

    /* Create and return a prefix of the form "filename:linenumber", taking care
       to avoid buffer overruns. */
    (void)strncpy(buffer,fpp_name,MAXLINE);
    buffer[MAXLINE] = '\0';
    n = strlen(buffer);
    buffer[n++] = ':';
    (void)sprintf(&buffer[n], "%d", FNR);
    buffer[sizeof(buffer)-1] = '\0';
    return ((const char*)&buffer[0]);
}


static void
print_banner(VOID_ARG)
{
    PRINTF("%s %s\n",out_prefix,
	"=================================================================");
    PRINTF("%s %s\n",out_prefix,version());
    PRINTF("%s Date: %s\n",out_prefix,fpp_timestamp);
    PRINTF("%s Directory: %s\n",out_prefix,fpp_cwd);
    PRINTF("%s User: %s <%s%s%s>\n",
	   out_prefix,fpp_personal_name,fpp_user_name,
	   fpp_hostname[0] ? "@" : "",fpp_hostname);
    PRINTF("%s %s\n",out_prefix,
	"=================================================================");
}


#if STDC
int
main(int argc, char *argv[])
#else /* NOT STDC */
int
main(argc,argv)
int argc;
char *argv[];
#endif /* STDC */
{
    register int k;
    int nfiles;

    init();

    nfiles = 0;
    for (k = 1; k < argc; ++k)		/* process options */
    {
	switch (doarg(argv[k]))
	{
	case 0:				/* option */
	    argv[k] = (char*)NULL;
	    break;
	case 1:				/* last option */
	    argv[k] = (char*)NULL;
	    k = argc;
	    break;
	default:			/* file */
	    nfiles++;
	    break;
	}
    }

    print_banner();

    if (nfiles > 0)
    {
	for (k = 1; k < argc; ++k)		/* process files */
	{
	    if (argv[k] != (char*)NULL)
		dofile(argv[k]);
	}
    }
    else
	dofile((char*)NULL);

    if (ferror(stdout))			/* check for full disk et al */
	fpp_code = EXIT_FAILURE;

    exit (fpp_code);
    return (fpp_code);			/* keep optimizers happy */
}
